<?php declare(strict_types=1);

namespace Plugin\css_vip\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */

	public $_copyTable = true;

	public function copyTable($sourceDB,$destinationDB="", $copyTable=true,$deleteSourceDB=false) {
		if(	$this->_copyTable === false ) {
			return;
		}
		self::JTLWriteLog('starte copy '.$sourceDB);
		$result = $this->getDB()->query("SHOW TABLES LIKE '".$sourceDB."'",2);
		if($copyTable && $result !== null && is_array($result) && count($result)) {
			error_log('DB Vorhanden '.$sourceDB);
			$result = $this->getDB()->query("SELECT * FROM ".$sourceDB." WHERE 1",2);
			foreach($result as $oItem) {
				error_log('schreibe Datensatz nach '.$destinationDB);
				$this->getDB()->insert($destinationDB,$oItem);
			}
		}
		if($deleteSourceDB) {
			$this->execute("DROP TABLE IF EXISTS ".$sourceDB,3);
		}
	}



	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	/*
	define('JTLLOG_LEVEL_EMERGENCY', 600);
	define('JTLLOG_LEVEL_ALERT', 550);
	define('JTLLOG_LEVEL_CRITICAL', 500);
	define('JTLLOG_LEVEL_ERROR', 400);
	define('JTLLOG_LEVEL_WARNING', 300);
	define('JTLLOG_LEVEL_NOTICE', 250);
	define('JTLLOG_LEVEL_INFO', 200);
	define('JTLLOG_LEVEL_DEBUG', 100);
*/

	public function JTLWriteLog($cLog = '', $nLevel = JTLLOG_LEVEL_INFO, $bForce = false) {
		if (\mb_strlen($cLog) > 0 && ($bForce || Jtllog::getSytemlogFlag(false))) {
			$logger = Shop::Container()->getLogService();
			$logger = $logger->withName("css_vip");
			$logger->log($nLevel, $cLog, ["css_vip"]);
			return true;
		}
		return false;
	}


	public function up() {
		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_vipConfig` (
								  `version` varchar(10) NOT NULL DEFAULT '2.0.0',
								  `sqlupdate` int(10) NOT NULL DEFAULT 0,
                  `pluginActive` char(1) NOT NULL default 'N',
                  `framework` char(10) NOT NULL default 'B4',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
								  `nettopreise` int(1) NOT NULL DEFAULT 1,
								  `maxLifeTime` int(11) NOT NULL DEFAULT 365,
								  `switchIfKampagne` varchar(1) NOT NULL DEFAULT 'N',
								  `cookieName` varchar(250) NOT NULL DEFAULT 'css_vip',
								  `kundengruppe` text NOT NULL,
								  `headerPosition` varchar(250) NOT NULL DEFAULT 'before',
								  `headerSelector` varchar(250) NOT NULL DEFAULT 'header',
								  `footerPosition` varchar(250) NOT NULL DEFAULT 'append',
								  `footerSelector` varchar(250) NOT NULL DEFAULT 'body',
								  `headerButtonBackground` varchar(20) NOT NULL DEFAULT '#18bf1b',
								  `headerButtonColor` varchar(20) NOT NULL DEFAULT '#ffffff',
								  `headerButtonBackgroundHover` varchar(20) NOT NULL DEFAULT '#18bf1b',
								  `headerButtonColorHover` varchar(20) NOT NULL DEFAULT '#ffffff',
								  `footerButtonBackground` varchar(20) NOT NULL DEFAULT '#18bf1b',
								  `footerButtonColor` varchar(20) NOT NULL DEFAULT '#ffffff',
								  `footerButtonBackgroundHover` varchar(20) NOT NULL DEFAULT '#18bf1b',
								  `footerButtonColorHover` varchar(20) NOT NULL DEFAULT '#ffffff',
								  `footerBannerBackground` varchar(20) NOT NULL DEFAULT '#000000',
								  `footerBannerColor` varchar(20) NOT NULL DEFAULT '#ffffff',
								  `headerBannerBackground` varchar(20) NOT NULL DEFAULT '#000000',
								  `headerBannerColor` varchar(20) NOT NULL DEFAULT '#ffffff',
								  `headerBannerFontSize` int(3) NOT NULL DEFAULT 14,
								  `footerBannerFontSize` int(3) NOT NULL DEFAULT 14,
								  `headerButtonFontSize` int(3) NOT NULL DEFAULT 14,
								  `footerButtonFontSize` int(3) NOT NULL DEFAULT 14,
								  `checkboxChecked` char(1) NOT NULL DEFAULT 'Y',
								  `weiterleitung` text NOT NULL,
								  `changeGroupInDb` char(1) NOT NULL DEFAULT 'N',
								  `groupCanChange` text NOT NULL,
								  `showIfVipGroup` char(1) NOT NULL DEFAULT 'N',
								  `groupNoChange` text NOT NULL,
								  `LoginUsedAccountGroup` varchar(1) DEFAULT 'Y'
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		if (($obj = $this->tableExist('css_vipConfig')) && $obj->Rows > 0) {
			$this->_copyTable = false;
			self::JTLWriteLog('Es ist kein Import erforderlich');
		} else {
			self::JTLWriteLog('Import wird gestartet');
			$this->copyTable("css_vip_konfig", "css_vipConfig", true, false);
		}

		if (($obj = $this->tableExist('css_vipConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_vipConfig set `version` = '2.0.0' ");
		} else {
			$this->execute(
				"INSERT INTO `css_vipConfig` (`version`) VALUES ('2.0.0')"
			);
		}
	}
	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
