<?php declare(strict_types=1);

namespace Plugin\css_vip\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20231006123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20231006123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	/*
	define('JTLLOG_LEVEL_EMERGENCY', 600);
	define('JTLLOG_LEVEL_ALERT', 550);
	define('JTLLOG_LEVEL_CRITICAL', 500);
	define('JTLLOG_LEVEL_ERROR', 400);
	define('JTLLOG_LEVEL_WARNING', 300);
	define('JTLLOG_LEVEL_NOTICE', 250);
	define('JTLLOG_LEVEL_INFO', 200);
	define('JTLLOG_LEVEL_DEBUG', 100);
*/

	public function JTLWriteLog($cLog = '', $nLevel = JTLLOG_LEVEL_INFO, $bForce = false) {
		if (\mb_strlen($cLog) > 0 && ($bForce || Jtllog::getSytemlogFlag(false))) {
			$logger = Shop::Container()->getLogService();
			$logger = $logger->withName("css_vip");
			$logger->log($nLevel, $cLog, ["css_vip"]);
			return true;
		}
		return false;
	}




	public function up() {

		if($this->columnExist('css_vipConfig','nonCaseSensitive') === false) {
			$this->execute(
				"ALTER TABLE `css_vipConfig` ADD `nonCaseSensitive` CHAR(1) NOT NULL DEFAULT 'Y'"
			);
		}


		if (($obj = $this->tableExist('css_vipConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_vipConfig set `version` = '2.0.1' ");
		} else {
			$this->execute(
				"INSERT INTO `css_vipConfig` (`version`) VALUES ('2.0.1')"
			);
		}
	}
	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
