(function () {
    'use strict';

    var cssVIPClass = function (options) {
        this.init(options);
    };

    cssVIPClass.VERSION = '2.0.0';
    cssVIPClass.VIPS = {
        showDebug: false
    };

    cssVIPClass.prototype = {
        constructor: cssVIPClass,
        init: function (options) {
            this.options = $.extend({}, cssVIPClass.VIPS, options);
            var that = this;
            that.initPlugin();
        },
        register: function (options) {
            var that = this;
            this.debug("ich starte cssVIPClass.VERSION " + this.__proto__.constructor.VERSION);
        },

        debug: function (s) {
            if (this.options.showDebug) {
                console.log(s);
            }
        },

        _set: function (key, value) {
            this.options.key = value;
        },


        initPlugin: function () {
            var that = this;
            $(document).on('shown.bs.modal', function(){
                $("#vipPassword").focus();
            });
            $("body").on("keyup", "#vipPassword", function(e) {
                switch(e.keyCode) {
                    case 13: $("button[data-action='switch-vip']").trigger("click");
                        break;
                }
            });

            $("body").on("click","button[data-action='change-vip'], a[data-action='change-vip'], .change-vip", function(el) {
                el.preventDefault();
                var token = $(this).data('token');
                var pass = ""; //  encodeURI($('#vipPassword').val());
                var data = "io=css_vip&jtl_token=" + token + "&action=change-vip&vipPassword="+ pass;
                var ioUrl = $(this).data("io");
                that.post_data(ioUrl,data);
                return false;
            });
            $("body").on("click","button[data-action='switch-vip']", function() {
                var token = $(this).data('token');
                var pass = encodeURI($('#vipPassword').val());
                if($("input[name='SaveCookie']:checked").length) {
                    var SaveCookie = "&SaveCookie=Y";
                } else {
                    var SaveCookie='';
                }
                var data = "io=css_vip&jtl_token=" + token + "&action=switch-vip" + SaveCookie +"&vipPassword="+ pass;
                $(".css-vip-modal .has-error").removeClass("has-error");
                var ioUrl = $(this).data("io");
                if($(".css-vip-error").length) {
                    $(".css-vip-error").slideUp("slow",function() {
                        $(".css-vip-error").remove();
                        that.post_data(ioUrl,data);
                    });
                } else {
                    that.post_data(ioUrl,data);
                }
            });
        },


        post_data: function (url, data) {
            var that = this;
            jQuery.ajax({
                type: 'POST',
                url: url,
                data: data,
                showNoSuggestionNotice: true,
                dataType: 'json',
                beforeSend: function (jqXHR) {
                    jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
                },
                success: function (data, responseText, jqXHR) {
                    if (jqXHR.status == 204) {
                        that.debug('sorry, here is nothing to do for me. (Token problem?)')
                        return false;
                    }
                    if (jqXHR.status == 404) {
                        that.debug('sorry, here is nothing to show you.')
                        return false;
                    }
                    if (jqXHR.status == 403) {
                        that.debug('sorry, this is no place for you.')
                        return false;
                    }
                    //debug(data);
                    if (data.script) {
                        eval(data.script);
                    }
                },
                error: function () {
                    that.debug('something is wrong....anything buggy?');
                },
                complete: function () {
                }
            });
        },
    };

    $.cssVIP = function (options) {
        $.cssVIP = new cssVIPClass(options);
        $.cssVIP.register();
        return $.cssVIP;
    };

})(jQuery);


// console.log("ich starte vip");

$(function() {
    $.cssVIP({
        showDebug: false
    });
});

